#ifdef IN_MODULE_XPCOMSupport
#define XPCOMSUPPORT_PRE CDA_EXPORT_PRE
#define XPCOMSUPPORT_POST CDA_EXPORT_POST
#else
#define XPCOMSUPPORT_PRE CDA_IMPORT_PRE
#define XPCOMSUPPORT_POST CDA_IMPORT_POST
#endif

class X2PFactory
{
public:
  XPCOMSUPPORT_PRE X2PFactory(const char* aInterface, nsIID aIID) XPCOMSUPPORT_POST
    : mInterface(aInterface)
  {
    if (mEntries == nsnull)
    {
      mEntries = new nsDataHashtable<nsIDHashKey,X2PFactory*>();
      mEntries->Init();
    }
    mEntries->Put(aIID, this);
  }

  XPCOMSUPPORT_PRE static X2PFactory* FindFactory(nsIID aIID) XPCOMSUPPORT_POST
  {
    if (mEntries == nsnull)
      return nsnull;

    X2PFactory* xf = nsnull;
    mEntries->Get(aIID, &xf);
    return xf;
  }

  XPCOMSUPPORT_PRE const char* GetID() XPCOMSUPPORT_POST
  {
    return mInterface;
  }

  XPCOMSUPPORT_PRE virtual void* MakeX2P(void* aObj) XPCOMSUPPORT_POST = 0;

private:
  XPCOMSUPPORT_PRE static nsDataHashtable<nsIDHashKey,X2PFactory*>* mEntries XPCOMSUPPORT_POST;
  const char* mInterface;
};
