#ifndef INCLUDED_X2PXPCOM_HXX
#define INCLUDED_X2PXPCOM_HXX
#include <exception>
#include "Utilities.hxx"
#ifdef HAVE_INTTYPES_H
#include <inttypes.h>
#endif
#include <nsISupports.h>
#include "Ifacexpcom.hxx"
#include <nsCOMPtr.h>
#include <nsDataHashtable.h>

#ifdef IN_MODULE_XPCOMSupport
#define XPCOMSUPPORT_PRE CDA_EXPORT_PRE
#define XPCOMSUPPORT_POST CDA_EXPORT_POST
#else
#define XPCOMSUPPORT_PRE CDA_IMPORT_PRE
#define XPCOMSUPPORT_POST CDA_IMPORT_POST
#endif

namespace x2p
{
  namespace XPCOM
  {
    XPCOMSUPPORT_PRE class IObject
    // We don't actually need to inherit from nsISupports directly.
    /* : public virtual nsISupports */
    {
    public:
      XPCOMSUPPORT_PRE IObject() XPCOMSUPPORT_POST;
      XPCOMSUPPORT_PRE IObject(iface::XPCOM::IObject*) XPCOMSUPPORT_POST;
      XPCOMSUPPORT_PRE virtual ~IObject() XPCOMSUPPORT_POST {};
      XPCOMSUPPORT_PRE nsrefcnt AddRef() XPCOMSUPPORT_POST
      {
        return _refcount++;
      }
      XPCOMSUPPORT_PRE nsrefcnt Release() XPCOMSUPPORT_POST
      {
        _refcount--;
        if (_refcount != 0)
          return _refcount;
        delete this;
        return 0;
      }
      XPCOMSUPPORT_PRE nsresult QueryInterface(REFNSIID aIID, void** aInstancePtr) XPCOMSUPPORT_POST;
    protected:
      iface::XPCOM::IObject* mObj;
    private:
      nsrefcnt _refcount;
    } XPCOMSUPPORT_POST;
  };
};

class X2PISupports
  : public x2p::XPCOM::IObject, public nsISupports
{
public:
  X2PISupports(iface::XPCOM::IObject* aObj)
    : x2p::XPCOM::IObject(aObj)
  {
  }

  ~X2PISupports()
  {
  }

  NS_DECL_ISUPPORTS;
};

#endif // INCLUDED_X2PXPCOM_HXX
